// ------------------------------------------------------------
// dSvZ
// 
// Copyright (c) 2004 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------

float inv_size = 1/256;

// ------------------------------------------------------------
// Textures(eNX`)
// ------------------------------------------------------------
texture LinearTex;
sampler LinearSamp = sampler_state
{
    Texture = <LinearTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
texture PointTex;
sampler PointSamp = sampler_state
{
    Texture = <PointTex>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

// ------------------------------------------------------------
// dςo͂
// ------------------------------------------------------------
struct FRAGMENT0
{
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
	float4 XY			: TEXCOORD1;
};
// ------------------------------------------------------------
FRAGMENT0 VS0 (
      float4 Pos    : POSITION           // (f̒_)
    , float2 Tex    : TEXCOORD0          // (eNX`W)
      )
{
    FRAGMENT0 Out = (FRAGMENT0)0;
    
	// Position(ʒuW)
	Out.Pos = Pos;
	
	// [0,1]ɂʒu
	Out.XY = 1;
	Out.XY.x = (  0.5 * Pos.x + 0.5);
	Out.XY.y = (- 0.5 * Pos.y + 0.5);
	
	// eNX`W
	Out.Tex = Tex;
	
    return Out;
}
// ------------------------------------------------------------
float4 PS0 (FRAGMENT0 In) : COLOR
{
	float4 Out;
	
	Out = tex2D( LinearSamp, In.Tex ).x * In.XY;
	
	return Out;
}



// ------------------------------------------------------------
// ϑ
// ------------------------------------------------------------
struct FRAGMENT1
{
    float4 Pos			: POSITION;
	float2 Tex0			: TEXCOORD0;
	float2 Tex1			: TEXCOORD1;
	float2 Tex2			: TEXCOORD2;
	float2 Tex3			: TEXCOORD3;
	float2 Tex4			: TEXCOORD4;
	float2 Tex5			: TEXCOORD5;
	float2 Tex6			: TEXCOORD6;
	float2 Tex7			: TEXCOORD7;
};
// ------------------------------------------------------------
FRAGMENT1 VS1 (
      float4 Pos    : POSITION           // (f̒_)
    , float2 Tex    : TEXCOORD0          // (eNX`W)
      )
{
    FRAGMENT1 Out = (FRAGMENT1)0;
    
	// Position(ʒuW)
	Out.Pos = Pos;
	
	// eNX`W
	Out.Tex0 = Tex + float2( 0.5*inv_size, 0.5*inv_size );
	Out.Tex1 = Tex + float2( 1.5*inv_size, 0.5*inv_size );
	Out.Tex2 = Tex + float2( 2.5*inv_size, 0.5*inv_size );
	Out.Tex3 = Tex + float2( 3.5*inv_size, 0.5*inv_size );
	Out.Tex4 = Tex + float2( 0.5*inv_size, 1.5*inv_size );
	Out.Tex5 = Tex + float2( 1.5*inv_size, 1.5*inv_size );
	Out.Tex6 = Tex + float2( 2.5*inv_size, 1.5*inv_size );
	Out.Tex7 = Tex + float2( 3.5*inv_size, 1.5*inv_size );
	
    return Out;
}
// ------------------------------------------------------------
float4 PS1 (FRAGMENT1 In) : COLOR
{
	float4 Out;
	
	Out = tex2D( PointSamp, In.Tex0 )
		+ tex2D( PointSamp, In.Tex1 )
		+ tex2D( PointSamp, In.Tex2 )
		+ tex2D( PointSamp, In.Tex3 )
		+ tex2D( PointSamp, In.Tex4 )
		+ tex2D( PointSamp, In.Tex5 )
		+ tex2D( PointSamp, In.Tex6 )
		+ tex2D( PointSamp, In.Tex7 )
		+ tex2D( PointSamp, In.Tex0 + float2( 0.0, 2.0*inv_size ) )
		+ tex2D( PointSamp, In.Tex1 + float2( 0.0, 2.0*inv_size ) )
		+ tex2D( PointSamp, In.Tex2 + float2( 0.0, 2.0*inv_size ) )
		+ tex2D( PointSamp, In.Tex3 + float2( 0.0, 2.0*inv_size ) )
		+ tex2D( PointSamp, In.Tex4 + float2( 0.0, 2.0*inv_size ) )
		+ tex2D( PointSamp, In.Tex5 + float2( 0.0, 2.0*inv_size ) )
		+ tex2D( PointSamp, In.Tex6 + float2( 0.0, 2.0*inv_size ) )
		+ tex2D( PointSamp, In.Tex7 + float2( 0.0, 2.0*inv_size ) );
	
	return Out/16;
}


// ------------------------------------------------------------
// ^[Qbg𓮂
// ------------------------------------------------------------
struct FRAGMENT2
{
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};
// ------------------------------------------------------------
float4 PS2 (FRAGMENT2 In) : COLOR
{
	float4 Out;
	
	float4 pos =  tex2D( PointSamp, float2(0.5,0.5) );
	pos /= pos.w;
	
	pos *= 512/32;

	Out =  tex2D( LinearSamp, In.Tex - pos.xy );

//	clip( Out.x-0.5 );// ()
	
	return Out;
}





// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique TShader
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS0();
        PixelShader  = compile ps_2_0 PS0();
    }
    
    pass P1
    {
        VertexShader = compile vs_1_1 VS1();
        PixelShader  = compile ps_2_0 PS1();
    }
    
    pass P2
    {
        PixelShader  = compile ps_2_0 PS2();
    }
}
