//-------------------------------------------------------------
// File: main.cpp
//
// Desc: dSvZ
// Copyright (c) 2004 IMAGIRE Takashi. All rights reserved.
//-------------------------------------------------------------
#define STRICT
#include <windows.h>
#include <time.h>
#include <commctrl.h>
#include <commdlg.h>
#include <basetsd.h>
#include <math.h>
#include <stdio.h>
#include <d3dx9.h>
#include <dxerr9.h>
#include <tchar.h>
#include "DXUtil.h"
#include "D3DEnumeration.h"
#include "D3DSettings.h"
#include "D3DApp.h"
#include "D3DFont.h"
#include "D3DFile.h"
#include "D3DUtil.h"
#include "resource.h"
#include "main.h"

#define MAP_SIZE			128

#define frand() ((float)rand()/(float)RAND_MAX)

//-------------------------------------------------------------
// Globals variables and definitions(O[oϐƒ`)
//-------------------------------------------------------------
CMyD3DApplication* g_pApp  = NULL;
HINSTANCE          g_hInst = NULL;

typedef struct {
    FLOAT       p[4];
    FLOAT       tu, tv;
} TVERTEX;

//-------------------------------------------------------------
// Name: WinMain()
// Desc: Entry point to the program. Initializes everything, and goes into a
//       message-processing loop. Idle time is used to render the scene.
//       (C֐)
//-------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    CMyD3DApplication d3dApp;

    g_pApp  = &d3dApp;
    g_hInst = hInst;

    InitCommonControls();
    if( FAILED( d3dApp.Create( hInst ) ) )
        return 0;

    return d3dApp.Run();
}




//-------------------------------------------------------------
// Name: CMyD3DApplication()
// Desc: Application constructor.   Paired with ~CMyD3DApplication()
//       Member variables should be initialized to a known state here.  
//       The application window has not yet been created and no Direct3D device 
//       has been created, so any initialization that depends on a window or 
//       Direct3D should be deferred to a later stage. 
//       (AvP[ṼRXgN^)
//-------------------------------------------------------------
CMyD3DApplication::CMyD3DApplication()
{
	time_t t;
	
	time( &t );
	srand( t );

    m_bDrop = 0;
    m_fDrop_x = 0;
    m_fDrop_y = 0;

	m_pMapZ						= NULL;
	m_pBackBufferTex			= NULL;
	m_pBackBufferSurf			= NULL;
	m_pDotTex					= NULL;
	m_pTargetTex				= NULL;
	m_pTex[0]					= NULL;
	m_pTex[1]					= NULL;
	m_pTex[2]					= NULL;
	m_pTex[3]					= NULL;
	m_pTex[4]					= NULL;
	m_pSurf[0]					= NULL;
	m_pSurf[1]					= NULL;
	m_pSurf[2]					= NULL;
	m_pSurf[3]					= NULL;
	m_pSurf[4]					= NULL;

	m_pEffect					= NULL;
	m_hTechnique  				= NULL;

	m_fWorldRotX                = -0.0f;
    m_fWorldRotY                = D3DX_PI*0.5f;
	m_fViewZoom				    = 27.0f;

	m_dwCreationWidth           = 512;
    m_dwCreationHeight          = 512;
    m_strWindowTitle            = TEXT( "main" );
    m_d3dEnumeration.AppUsesDepthBuffer   = TRUE;
	m_bStartFullscreen			= false;
	m_bShowCursorWhenFullscreen	= false;
 
    m_pFont                     = new CD3DFont( _T("Arial"), 12, D3DFONT_BOLD );
    m_bLoadingApp               = TRUE;

    ZeroMemory( &m_UserInput, sizeof(m_UserInput) );
}




//-------------------------------------------------------------
// Name: ~CMyD3DApplication()
// Desc: Application destructor.  Paired with CMyD3DApplication()
//       (fXgN^)
//-------------------------------------------------------------
CMyD3DApplication::~CMyD3DApplication()
{
}




//-------------------------------------------------------------
// Name: OneTimeSceneInit()
// Desc: Paired with FinalCleanup().
//       The window has been created and the IDirect3D9 interface has been
//       created, but the device has not been created yet.  Here you can
//       perform application-related initialization and cleanup that does
//       not depend on a device.
//      (xs
//		EBhȄIDirect3D9̏͏IĂ܂B
//		ALPDIRECT3DDEVICE9 ̏͏IĂ܂B)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::OneTimeSceneInit()
{
    // Drawing loading status message until app finishes loading
    // ([fBObZ[W\)
    SendMessage( m_hWnd, WM_PAINT, 0, 0 );

    m_bLoadingApp = FALSE;

    return S_OK;
}




//-------------------------------------------------------------
// Name: ConfirmDevice()
// Desc: Called during device initialization, this code checks the device
//       for some minimum set of capabilities
//       (̎ɌĂ΂܂BKvȔ\͂`FbN܂B)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::ConfirmDevice( D3DCAPS9* pCaps,
                     DWORD dwBehavior,    D3DFORMAT Format )
{
	UNREFERENCED_PARAMETER( Format );
    UNREFERENCED_PARAMETER( dwBehavior );
    UNREFERENCED_PARAMETER( pCaps );
    

    // No fallback, so need ps2.0
	// (sNZVF[_o[W`FbN)
    if( pCaps->PixelShaderVersion < D3DPS_VERSION(2,0) )
		return E_FAIL;

    // If device doesn't support 1.1 vertex shaders in HW, switch to SWVP.
    // _VF[_o[Wʂ\tgEFA_
    if( pCaps->VertexShaderVersion < D3DVS_VERSION(1,1)
    &&  0==(dwBehavior & D3DCREATE_SOFTWARE_VERTEXPROCESSING) )
			return E_FAIL;

    return S_OK;
}


//-------------------------------------------------------------
// Name: InitDeviceObjects()
// Desc: Paired with DeleteDeviceObjects()
//       The device has been created.  Resources that are not lost on
//       Reset() can be created here -- resources in D3DPOOL_MANAGED,
//       D3DPOOL_SCRATCH, or D3DPOOL_SYSTEMMEM.  Image surfaces created via
//       CreateImageSurface are never lost and can be created here.  Vertex
//       shaders and pixel shaders can also be created here as they are not
//       lost on Reset().
//      (foCXꂽ̏܂B
//		t[obt@tH[}bgfoCX̎ނςɒʉ߂܂B
//		ŊmۂDeleteDeviceObjects()ŊJ܂)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::InitDeviceObjects()
{
    HRESULT hr;

    // Load objects (f̓ǂݍ)
	D3DXCreateTextureFromFile(m_pd3dDevice, "dot.bmp",		&m_pDotTex);
	D3DXCreateTextureFromFile(m_pd3dDevice, "target.tga",	&m_pTargetTex);

	// Create textures
    // Create the effect(VF[_̓ǂݍ)
	LPD3DXBUFFER pErr;
    if( FAILED( hr = D3DXCreateEffectFromFile(
				m_pd3dDevice, "hlsl.fx", NULL, NULL, 
				D3DXSHADER_DEBUG , NULL, &m_pEffect, &pErr ))){
		MessageBox( NULL, (LPCTSTR)pErr->GetBufferPointer()
					, "ERROR", MB_OK);
		return DXTRACE_ERR( "CreateEffectFromFile", hr );
	}
	m_hTechnique = m_pEffect->GetTechniqueByName( "TShader" );

    // Init the font(tHg)
    m_pFont->InitDeviceObjects( m_pd3dDevice );

    return S_OK;
}

//-------------------------------------------------------------
// Name: RestoreDeviceObjects()
// Desc: Paired with InvalidateDeviceObjects()
//       The device exists, but may have just been Reset().  Resources in
//       D3DPOOL_DEFAULT and any other device state that persists during
//       rendering should be set here.  Render states, matrices, textures,
//       etc., that don't change during rendering can be set once here to
//       avoid redundant state setting during Render() or FrameMove().
//       (ʂ̃TCYύXꂽɌĂ΂܂B
//		 mۂInvalidateDeviceObjects()ŊJ܂B)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::RestoreDeviceObjects()
{
	DWORD i;

    // Setup a material (̐ݒ)
    D3DMATERIAL9 mtrl;
    D3DUtil_InitMaterial( mtrl, 1.0f, 0.0f, 0.0f );
    m_pd3dDevice->SetMaterial( &mtrl );

    // Set miscellaneous render states(_O̐ݒ)
    m_pd3dDevice->SetRenderState( D3DRS_DITHERENABLE,   FALSE );
    m_pd3dDevice->SetRenderState( D3DRS_SPECULARENABLE, FALSE );
    m_pd3dDevice->SetRenderState( D3DRS_ZENABLE,        TRUE );
    m_pd3dDevice->SetRenderState( D3DRS_AMBIENT,        0x000F0F0F );
    
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_MODULATE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
    m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );
    m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
    m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
    m_pd3dDevice->SetSamplerState( 0, D3DSAMP_ADDRESSU, D3DTADDRESS_CLAMP );
    m_pd3dDevice->SetSamplerState( 0, D3DSAMP_ADDRESSV, D3DTADDRESS_CLAMP );

    // World transform to identity ([hs)
    D3DXMATRIX matIdentity;
    D3DXMatrixIdentity( &m_mWorld );

    // Set up the view parameters for the camera(r[s)
    D3DXVECTOR3 vFromPt   = D3DXVECTOR3( 0.0f, 0.0f, -5.0f );
    D3DXVECTOR3 vLookatPt = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec    = D3DXVECTOR3( 0.0f, 1.0f, 0.0f );
    D3DXMatrixLookAtLH( &m_mView, &vFromPt, &vLookatPt, &vUpVec );

    // Set the camera projection matrix(ˉes)
    FLOAT fAspect = ((FLOAT)m_d3dsdBackBuffer.Width) / m_d3dsdBackBuffer.Height;
    D3DXMatrixPerspectiveFovLH( &m_mProj, 0.47108996f, fAspect, 1.0f, 100.0f );
	

	// Tetrahedron Matrix
	D3DXVECTOR3 lookat[4];
	D3DXVECTOR3 center;
	D3DXMATRIX mRot;
	float theta = 109.0f * D3DX_PI / 180.0f;
	center = D3DXVECTOR3(0,0,0);
	lookat[0] = D3DXVECTOR3(0,0,1);
	lookat[1] = D3DXVECTOR3(sinf(theta)*cosf(0.0*D3DX_PI/3.0f),sinf(theta)*sinf(0.0*D3DX_PI/3.0f), cosf(theta));
	lookat[2] = D3DXVECTOR3(sinf(theta)*cosf(2.0*D3DX_PI/3.0f),sinf(theta)*sinf(2.0*D3DX_PI/3.0f), cosf(theta));
	lookat[3] = D3DXVECTOR3(sinf(theta)*cosf(4.0*D3DX_PI/3.0f),sinf(theta)*sinf(4.0*D3DX_PI/3.0f), cosf(theta));
	
    // Create the stencil buffer to be used with the paraboloid textures([x}bv̐)
	if (FAILED(m_pd3dDevice->CreateDepthStencilSurface(MAP_SIZE, MAP_SIZE, 
		D3DFMT_D16, D3DMULTISAMPLE_NONE, 0, TRUE, &m_pMapZ, NULL)))
		return E_FAIL;

	if (FAILED(m_pd3dDevice->CreateTexture( 512, 512, 1, 
		D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, &m_pBackBufferTex, NULL)))
		return E_FAIL;
	if (FAILED(m_pBackBufferTex->GetSurfaceLevel(0, &m_pBackBufferSurf)))
		return E_FAIL;
	m_bClear = TRUE;

	DWORD size = 256;
	for( i = 0; i < 5; i++ )
	{
		if (FAILED(m_pd3dDevice->CreateTexture( size, size, 1, 
			D3DUSAGE_RENDERTARGET, D3DFMT_A16B16G16R16F, D3DPOOL_DEFAULT, &m_pTex[i], NULL)))
			return E_FAIL;
		if (FAILED(m_pTex[i]->GetSurfaceLevel(0, &m_pSurf[i])))
			return E_FAIL;
		size /= 4;
	}

    // Restore effect object
	m_pEffect->OnResetDevice();

    // Restore the font(tHg)
    m_pFont->RestoreDeviceObjects();

	return S_OK;
}


//-------------------------------------------------------------
// Name: FrameMove()
// Desc: Called once per frame, the call is the entry point for animating
//       the scene.
//       (t[Ă΂܂BAj̏Ȃǂs܂B)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::FrameMove()
{
    // Update user input state(̓f[^̍XV)
    UpdateInput( &m_UserInput );

	//---------------------------------------------------------
    // Update the world state according to user input(͂ɉčWnXV)
	//---------------------------------------------------------
	// Rotation(])
    D3DXMATRIX matRotY;
    D3DXMATRIX matRotX;

	if( m_UserInput.bRotateLeft && !m_UserInput.bRotateRight )
		m_fWorldRotY += m_fElapsedTime;
	else
	if( m_UserInput.bRotateRight && !m_UserInput.bRotateLeft )
		m_fWorldRotY -= m_fElapsedTime;

	if( m_UserInput.bRotateUp && !m_UserInput.bRotateDown )
		m_fWorldRotX += m_fElapsedTime;
	else
	if( m_UserInput.bRotateDown && !m_UserInput.bRotateUp )
		m_fWorldRotX -= m_fElapsedTime;

    D3DXMatrixRotationX( &matRotX, m_fWorldRotX );
    D3DXMatrixRotationY( &matRotY, m_fWorldRotY );

    D3DXMatrixMultiply( &m_mWorld, &matRotY, &matRotX );
	
	//---------------------------------------------------------
	// Update view matrix(r[s̐ݒ)
	//---------------------------------------------------------
	// Zoom(Y[)
    if( m_UserInput.bZoomIn && !m_UserInput.bZoomOut )
        m_fViewZoom += m_fElapsedTime;
    else if( m_UserInput.bZoomOut && !m_UserInput.bZoomIn )
        m_fViewZoom -= m_fElapsedTime;

    D3DXVECTOR3 vFromPt   = D3DXVECTOR3( 0.0f, 0.0f, -m_fViewZoom );
    D3DXVECTOR3 vLookatPt = D3DXVECTOR3( 0.0f, 0.3f, 0.0f );
    D3DXVECTOR3 vUpVec    = D3DXVECTOR3( 0.0f, 1.0f, 0.0f );
    D3DXMatrixLookAtLH( &m_mView, &vFromPt, &vLookatPt, &vUpVec );

	return S_OK;
}
//-------------------------------------------------------------
// Name: UpdateInput()
// Desc: Update the user input.  Called once per frame 
//       (̓f[^XV)
//-------------------------------------------------------------
void CMyD3DApplication::UpdateInput( UserInput* pUserInput )
{
    pUserInput->bRotateUp    = ( m_bActive && (GetAsyncKeyState( VK_UP )    & 0x8000) == 0x8000 );
    pUserInput->bRotateDown  = ( m_bActive && (GetAsyncKeyState( VK_DOWN )  & 0x8000) == 0x8000 );
    pUserInput->bRotateLeft  = ( m_bActive && (GetAsyncKeyState( VK_LEFT )  & 0x8000) == 0x8000 );
    pUserInput->bRotateRight = ( m_bActive && (GetAsyncKeyState( VK_RIGHT ) & 0x8000) == 0x8000 );
    
}





//-------------------------------------------------------------
// Name: Render()
// Desc: Called once per frame, the call is the entry point for 3d
//       rendering. This function sets up render states, clears the
//       viewport, and renders the scene.
//       (ʂ`悷)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::Render()
{
	LPDIRECT3DSURFACE9 pOldBackBuffer, pOldZBuffer;
	D3DVIEWPORT9 oldViewport;
    D3DXMATRIX m, mT, mR, mW, mView, mProj;
	DWORD i;
	D3DXVECTOR4 v;
	D3DMATERIAL9 *pMtrl;

	// Begin the scene(`Jn)
    if( SUCCEEDED( m_pd3dDevice->BeginScene() ) )
    {
		D3DVIEWPORT9 viewport = {0, 0   // x,y(̍W)
						, 512, 512			// width, height(,)
						, 0.0f,1.0f};   // near, far(OʁA)

		//-------------------------------------------------
		// Backup rendering target(_O^[Qbg̕ۑ)
		//-------------------------------------------------
		m_pd3dDevice->GetRenderTarget( 0, &pOldBackBuffer );
		m_pd3dDevice->GetDepthStencilSurface( &pOldZBuffer );
		m_pd3dDevice->GetViewport( &oldViewport );

		m_pd3dDevice->SetRenderTarget( 0, m_pBackBufferSurf );
		m_pd3dDevice->SetDepthStencilSurface( NULL );
		m_pd3dDevice->SetViewport( &viewport );

		// Clear the scene
		if(m_bClear)
		{
			m_bClear = FALSE;
			m_pd3dDevice->Clear(0L, NULL
				, D3DCLEAR_TARGET
				, 0x00000000, 1.0f, 0L);
		}

		if(m_bDrop)
		{// _ł
			m_pd3dDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
			m_pd3dDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
			m_pd3dDevice->SetRenderState(D3DRS_SRCBLEND,  D3DBLEND_ONE);
			m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
			m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
			m_pd3dDevice->SetTextureStageState(1,D3DTSS_COLOROP,    D3DTOP_DISABLE);
			m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
			m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
			m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
			float r = 16;
			TVERTEX Vertex[4] = {
				//    x          y         z rhw tu tv
				{m_fDrop_x-r, m_fDrop_y-r, 0, 1, 0, 0,},
				{m_fDrop_x+r, m_fDrop_y-r, 0, 1, 1, 0,},
				{m_fDrop_x+r, m_fDrop_y+r, 0, 1, 1, 1,},
				{m_fDrop_x-r, m_fDrop_y+r, 0, 1, 0, 1,},
			};
			m_pd3dDevice->SetTexture( 0, m_pDotTex );
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );
			m_pd3dDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
		}
		
		if( m_pEffect != NULL ) 
		{
			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );

			// 0 
			m_pEffect->Pass( 0 );
			m_pd3dDevice->SetRenderTarget( 0, m_pSurf[0] );
			m_pd3dDevice->SetFVF( D3DFVF_XYZ | D3DFVF_TEX1 );
			TVERTEX Vertex[4] = {
				// x   y  z      tu            tv
				{ -1,  1, 0,  0+1.0/512.0, 0+1.0/512.0,},
				{  1,  1, 0,  1+1.0/512.0, 0+1.0/512.0,},
				{  1, -1, 0,  1+1.0/512.0, 1+1.0/512.0,},
				{ -1, -1, 0,  0+1.0/512.0, 1+1.0/512.0,},
			};
			m_pEffect->SetTexture( "LinearTex",  m_pBackBufferTex );
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );

			// 1R
			m_pEffect->Pass( 1 );
			float size = 256.0;
			for( i = 1; i < 5; i++ )
			{
				m_pEffect->SetFloat("inv_size", 1.0/size);
				m_pd3dDevice->SetRenderTarget( 0, m_pSurf[i] );
				TVERTEX Vertex[4] = {
					// x   y  z   tu tv
					{ -1,  1, 0,  0, 0,},
					{  1,  1, 0,  1, 0,},
					{  1, -1, 0,  1, 1,},
					{ -1, -1, 0,  0, 1,},
				};
				m_pEffect->SetTexture( "PointTex",  m_pTex[i-1] );
				m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );

				size /= 4.0;
			}
			m_pEffect->End();
		}

		//-----------------------------------------------------
		// Restore render target
		// (_O^[Qbgɖ߂)
		//-----------------------------------------------------
		m_pd3dDevice->SetRenderTarget(0, pOldBackBuffer);
		m_pd3dDevice->SetRenderTarget(1, NULL);
		m_pd3dDevice->SetDepthStencilSurface(pOldZBuffer);
		m_pd3dDevice->SetViewport(&oldViewport);
		pOldBackBuffer->Release();
		pOldZBuffer->Release();


		{// Sʕ\
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
		m_pd3dDevice->SetTextureStageState(1,D3DTSS_COLOROP,    D3DTOP_DISABLE);
		m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
		m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_POINT );
		m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
		TVERTEX Vertex[4] = {
			//    x                             y         z rhw tu tv
			{  0, 0, 0, 1, 0, 0,},
			{(FLOAT)m_d3dsdBackBuffer.Width, 0, 0, 1, 1, 0,},
			{(FLOAT)m_d3dsdBackBuffer.Width, (FLOAT)m_d3dsdBackBuffer.Height, 0, 1, 1, 1,},
			{  0, (FLOAT)m_d3dsdBackBuffer.Height, 0, 1, 0, 1,},
		};
		m_pd3dDevice->SetTexture( 0, m_pBackBufferTex );
		m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );
		}
		
		// dS̕\
		if( m_pEffect != NULL ) 
		{
			m_pEffect->SetTechnique( m_hTechnique );
			m_pEffect->Begin( NULL, 0 );
			m_pEffect->Pass( 2 );

			m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
			m_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
			m_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );

			m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
			TVERTEX Vertex[4] = {
			//                  x                                  y          z rhw tu tv
			{                             0,                               0, 0, 1, 0.5,        0.5,},
			{(FLOAT)m_d3dsdBackBuffer.Width,                               0, 0, 1, 0.5+512/32, 0.5,},
			{(FLOAT)m_d3dsdBackBuffer.Width, (FLOAT)m_d3dsdBackBuffer.Height, 0, 1, 0.5+512/32, 0.5+512/32,},
			{                             0, (FLOAT)m_d3dsdBackBuffer.Height, 0, 1, 0.5,        0.5+512/32,},
			};
			m_pEffect->SetTexture( "PointTex",  m_pTex[4] );
			m_pEffect->SetTexture( "LinearTex", m_pTargetTex );
			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );

			m_pEffect->End();
			m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );
		}



		// Render stats and help text(wv̕\)
        RenderText();

#ifdef _DEBUG // Textures are displaying when debugging, (fobOpɃeNX`\)
		{
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
		m_pd3dDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
		m_pd3dDevice->SetTextureStageState(1,D3DTSS_COLOROP,    D3DTOP_DISABLE);
		m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
		m_pd3dDevice->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_POINT );
		m_pd3dDevice->SetFVF( D3DFVF_XYZRHW | D3DFVF_TEX1 );
		float scale = 64.0f;
		for(DWORD i=0; i<5; i++){
			TVERTEX Vertex[4] = {
				//    x                             y         z rhw tu tv
				{(i+0)*scale, (FLOAT)m_d3dsdBackBuffer.Height-scale, 0, 1, 0, 0,},
				{(i+1)*scale, (FLOAT)m_d3dsdBackBuffer.Height-scale, 0, 1, 1, 0,},
				{(i+1)*scale, (FLOAT)m_d3dsdBackBuffer.Height-    0, 0, 1, 1, 1,},
				{(i+0)*scale, (FLOAT)m_d3dsdBackBuffer.Height-    0, 0, 1, 0, 1,},
			};
			if(0==i) m_pd3dDevice->SetTexture( 0, m_pTex[0] );
			if(1==i) m_pd3dDevice->SetTexture( 0, m_pTex[1] );
			if(2==i) m_pd3dDevice->SetTexture( 0, m_pTex[2] );
			if(3==i) m_pd3dDevice->SetTexture( 0, m_pTex[3] );
			if(4==i) m_pd3dDevice->SetTexture( 0, m_pTex[4] );

			m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TVERTEX ) );
		}
		}
#endif		

		// End the scene.(`̏I)
        m_pd3dDevice->EndScene();
    }

    return S_OK;
}




//-------------------------------------------------------------
// Name: RenderText()
// Desc: Draw the help & statistics for running sample
//       (Ԃwvʂɕ\)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::RenderText()
{
    D3DCOLOR fontColor        = D3DCOLOR_ARGB(255,255,255,0);
    TCHAR szMsg[MAX_PATH] = TEXT("");
    FLOAT fNextLine;

    // Draw help
    fNextLine = 0; 

    lstrcpy( szMsg, TEXT("Press 'F2' to configure display") );
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );
    fNextLine += 20.0f;

    lstrcpy( szMsg, TEXT("Press 'A' to change shader") );
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );
    fNextLine += 20.0f;

    // Output statistics
    lstrcpy( szMsg, m_strDeviceStats );
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );
    fNextLine += 20.0f;
    lstrcpy( szMsg, m_strFrameStats );
    m_pFont->DrawText( 2, fNextLine, fontColor, szMsg );
    fNextLine += 20.0f;
	
	return S_OK;
}


// ----------------------------------------------------------------------------
void CMyD3DApplication::SetDrop(float x , float y)
{
    m_bDrop = 100;
    m_fDrop_x = x;
    m_fDrop_y = y;
}
// ----------------------------------------------------------------------------
void CMyD3DApplication::ResetDrop()
{
    m_bDrop = 0;
}
// ----------------------------------------------------------------------------
int CMyD3DApplication::IsDrop()
{
    return m_bDrop;
}


//-------------------------------------------------------------
// Name: MsgProc()
// Desc: Overrrides the main WndProc, so the sample can do custom message
//       handling (e.g. processing mouse, keyboard, or menu commands).
//       (WndProc I[o[Ch)
//-------------------------------------------------------------
LRESULT CMyD3DApplication::MsgProc( HWND hWnd, UINT msg,
                                 WPARAM wParam, LPARAM lParam )
{
    long x, y;
    switch( msg )
    {
        case WM_PAINT:
        {
            if( m_bLoadingApp )
            {
                // Loading message([h)
                HDC hDC = GetDC( hWnd );
                TCHAR strMsg[MAX_PATH];
                wsprintf(strMsg, TEXT("Loading... Please wait"));
                RECT rct;
                GetClientRect( hWnd, &rct );
                DrawText( hDC, strMsg, -1, &rct
                		, DT_CENTER|DT_VCENTER|DT_SINGLELINE );
                ReleaseDC( hWnd, hDC );
            }
            break;
        }
		case WM_LBUTTONDOWN:
			x = (lParam << 16) >> 16;
			y = lParam >> 16;
			SetDrop((float)x , (float)y);
			break;
		case WM_MOUSEMOVE:
			x = (lParam << 16) >> 16;
			y = lParam >> 16;
			if(IsDrop())SetDrop((float)x , (float)y);
			break;
		case WM_LBUTTONUP:
			ResetDrop();
			break;
		case WM_KEYDOWN:
			m_bClear = true;
			break;
    }

    return CD3DApplication::MsgProc( hWnd, msg, wParam, lParam );
}




//-------------------------------------------------------------
// Name: InvalidateDeviceObjects()
// Desc: Invalidates device objects.  Paired with RestoreDeviceObjects()
//       (RestoreDeviceObjects() ō쐬IuWFNg̊J)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::InvalidateDeviceObjects()
{
	// font(tHg)
    m_pFont->InvalidateDeviceObjects();

	SAFE_RELEASE(m_pSurf[4]);
	SAFE_RELEASE(m_pSurf[3]);
	SAFE_RELEASE(m_pSurf[2]);
	SAFE_RELEASE(m_pSurf[1]);
	SAFE_RELEASE(m_pSurf[0]);
	SAFE_RELEASE(m_pTex[4]);
	SAFE_RELEASE(m_pTex[3]);
	SAFE_RELEASE(m_pTex[2]);
	SAFE_RELEASE(m_pTex[1]);
	SAFE_RELEASE(m_pTex[0]);

	SAFE_RELEASE(m_pBackBufferSurf);
	SAFE_RELEASE(m_pBackBufferTex);
	SAFE_RELEASE(m_pMapZ);

	// Shaders(VF[_)
    if( m_pEffect    != NULL ) m_pEffect   ->OnLostDevice();

	return S_OK;
}




//-------------------------------------------------------------
// Name: DeleteDeviceObjects()
// Desc: Paired with InitDeviceObjects()
//       Called when the app is exiting, or the device is being changed,
//       this function deletes any device dependent objects.  
//       (InitDeviceObjects() ō쐬IuWFNgJ)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::DeleteDeviceObjects()
{
	// font(tHg)
    m_pFont->DeleteDeviceObjects();

	// Shaders(VF[_)
	SAFE_RELEASE( m_pEffect );
	
    // VF[_
	SAFE_RELEASE( m_pTargetTex );
	SAFE_RELEASE( m_pDotTex );

    return S_OK;
}




//-------------------------------------------------------------
// Name: FinalCleanup()
// Desc: Paired with OneTimeSceneInit()
//       Called before the app exits, this function gives the app the chance
//       to cleanup after itself.
//       (I钼OɌĂ΂)
//-------------------------------------------------------------
HRESULT CMyD3DApplication::FinalCleanup()
{
	// font(tHg)
    SAFE_DELETE( m_pFont );

    return S_OK;
}




