//-------------------------------------------------------------
// File: main.h
//
// Desc: dSvZ

// Copyright (c) 2004 IMAGIRE Takashi. All rights reserved.
//-------------------------------------------------------------
#pragma once

//-------------------------------------------------------------
// Defines, and constants(`萔)
//-------------------------------------------------------------

// Struct to store the current input state(݂̓̓f[^ۑ\)
struct UserInput
{
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
    BOOL bZoomIn;
    BOOL bZoomOut;
    BOOL bChangeShader;
    BOOL bPause;
};




//-------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: Main class to run this application. Most functionality is inherited
//       from the CD3DApplication base class.
//       (AvP[ṼNX)
//-------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
	// Shader
	LPD3DXEFFECT		    m_pEffect;				// Effect for the sample(GtFNg)
	D3DXHANDLE				m_hTechnique;			// Technique handle for RenderScene(eNjbN)

	// Rendering targets (_O^[Qbg)
	LPDIRECT3DSURFACE9		m_pMapZ;				// Depth buffer

	LPDIRECT3DTEXTURE9		m_pBackBufferTex;		// ʂɕ\
	LPDIRECT3DSURFACE9		m_pBackBufferSurf;
	BOOL					m_bClear;
	LPDIRECT3DTEXTURE9		m_pTex[5];				// _O^[Qbg
	LPDIRECT3DSURFACE9		m_pSurf[5];
	LPDIRECT3DTEXTURE9		m_pDotTex;				// ʂɑł_
	LPDIRECT3DTEXTURE9		m_pTargetTex;			// dS̕\

	float m_fDrop_x;
	float m_fDrop_y;
	int m_bDrop;

	// Geometry (ʏ̍Wϊs)
	D3DXMATRIX				m_mWorld;				// World matrix
	D3DXMATRIX				m_mView;				// View matrix
	D3DXMATRIX				m_mProj;				// Projection matrix

    FLOAT                   m_fWorldRotX;   // World rotation state X-axis(w])
    FLOAT                   m_fWorldRotY;   // World rotation state Y-axis(x])
    FLOAT                   m_fViewZoom;    // Distance to lookat (_̋)

	BOOL					m_bLoadingApp;	// TRUE, if the app is loading([hH)
    CD3DFont*				m_pFont;		// Font for drawing text(tHg)
    UserInput				m_UserInput;	// Struct for storing user input (̓f[^)

protected:
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice( D3DCAPS9*, DWORD, D3DFORMAT );

	void SetDrop(float x , float y);
	void ResetDrop();
	int  IsDrop();


	HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );
public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};

